<template>
    <div>
<!--        <v-row>-->
<!--            <v-col>-->
<!--                <v-card :loading="fetchingPositions">-->
<!--                    <v-card-title>-->
<!--                        <v-app-bar-->
<!--                            class="pl-2"-->
<!--                            color="white"-->
<!--                            flat-->
<!--                            dense-->
<!--                        >-->
<!--                            <v-btn-->
<!--                                class="primary"-->
<!--                                small-->
<!--                                icon-->
<!--                                @click="minimizePosition = !minimizePosition"-->
<!--                                :disabled="fetchingPositions"-->
<!--                            >-->
<!--                                <v-icon class="white&#45;&#45;text">-->
<!--                                    {{ minimizePosition ? 'mdi-window-maximize' : 'mdi-window-minimize'}}-->
<!--                                </v-icon>-->
<!--                            </v-btn>-->

<!--                            <v-toolbar-title>{{ $t('edit_', [$t('position')]) }}</v-toolbar-title>-->
<!--                        </v-app-bar>-->
<!--                    </v-card-title>-->

<!--                    <v-card-text v-if="!minimizePosition" class="pt-0">-->
<!--                        <ValidationObserver ref="positionObserver" v-slot="{ validate, reset }">-->
<!--                            <v-container class="pt-0">-->
<!--                                <v-row v-for="position in positions" :key="position.id">-->
<!--                                    <v-col class="pt-0">-->
<!--                                        <ValidationProvider v-slot="{ errors }" name="name" rules="required">-->
<!--                                            <v-text-field-->
<!--                                                v-model="position.name"-->
<!--                                                :error-messages="errors"-->
<!--                                                outlined-->
<!--                                            >-->
<!--                                            </v-text-field>-->
<!--                                        </ValidationProvider>-->
<!--                                    </v-col>-->
<!--                                </v-row>-->

<!--                                <v-row>-->
<!--                                    <v-col class="text-center">-->
<!--                                        <v-btn-->
<!--                                            :loading="loading"-->
<!--                                            color="primary"-->
<!--                                            @click="updatePositions"-->
<!--                                        >-->
<!--                                            <v-icon left>mdi-content-save</v-icon>-->
<!--                                            {{ $t('save') }}-->
<!--                                        </v-btn>-->
<!--                                    </v-col>-->
<!--                                </v-row>-->
<!--                            </v-container>-->
<!--                        </ValidationObserver>-->
<!--                    </v-card-text>-->
<!--                </v-card>-->
<!--            </v-col>-->
<!--        </v-row>-->
        <v-row>
            <v-col>
                <v-card>
                    <v-card-title>
                        <v-app-bar
                            class="pl-2"
                            color="white"
                            flat
                            dense
                        >
                            <v-btn
                                class="primary"
                                small
                                icon
                                @click="minimizeUpload = !minimizeUpload"
                            >
                                <v-icon class="white--text">
                                    {{ minimizeUpload ? 'mdi-window-maximize' : 'mdi-window-minimize'}}
                                </v-icon>
                            </v-btn>

                            <v-toolbar-title>{{ $t('upload_', [$t('banner')]) }}</v-toolbar-title>
                        </v-app-bar>
                    </v-card-title>

                    <v-card-text v-if="!minimizeUpload" class="pt-0">
                        <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                            <v-container class="pt-0">
                                <v-row>
                                    <v-col class="pt-0">
                                        <ValidationProvider v-slot="{ errors }" name="position" rules="required">
                                            <v-select
                                                v-model="position"
                                                item-text="name"
                                                item-value="id"
                                                :loading="fetchingPositions"
                                                :items="positions"
                                                :error-messages="errors"
                                                :menu-props="{ bottom: true, offsetY: true }"
                                                hide-details="auto"
                                                outlined
                                            >
                                            </v-select>
                                        </ValidationProvider>
                                    </v-col>
                                    <v-col>
                                        <v-switch
                                            v-model="viewport"
                                            label="Mobile View"
                                            true-value="mobile"
                                            false-value="desktop"
                                            hide-details
                                        >
                                        </v-switch>
                                    </v-col>
                                </v-row>

                                <v-row>
                                    <v-col>
                                        <ValidationProvider v-slot="{ errors }" name="banner" rules="required">
                                            <v-image-input
                                                v-model="uploading"
                                                :errors="errors"
                                                :placeholder="$t('banner')"
                                            >
                                            </v-image-input>
                                        </ValidationProvider>
                                    </v-col>
                                </v-row>

                                <v-row>
                                    <v-col class="text-center">
                                        <v-btn
                                            :loading="loading"
                                            color="primary"
                                            @click="upload"
                                        >
                                            <v-icon left>mdi-camera</v-icon>
                                            {{ $t('upload') }}
                                        </v-btn>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </ValidationObserver>
                    </v-card-text>
                </v-card>
            </v-col>
        </v-row>

        <v-row>
            <v-col>
                <v-card :loading="fetchingBanners">
                    <v-card-title>
                        <v-app-bar
                            class="pl-2"
                            color="white"
                            flat
                            dense
                        >
                            <v-btn
                                class="error"
                                small
                                icon
                                @click="showDelete = !showDelete"
                            >
                                <v-icon class="white--text">
                                    {{ showDelete ? 'mdi-delete-alert' : 'mdi-delete-off'}}
                                </v-icon>
                            </v-btn>

                            <v-toolbar-title>{{ $t('uploaded_', [$t('banner')]) }}</v-toolbar-title>
                        </v-app-bar>
                    </v-card-title>

                    <v-card-text class="pt-0" v-if="!fetchingPositions && !fetchingBanners">
                        <v-container>
                            <v-row>
                                <v-col>
                                    <v-chip class="mx-1" color="red" text-color="white" label>
                                        <v-icon left>mdi-tag</v-icon>
                                        {{ $t('desktop_view') }}
                                    </v-chip>

                                    <v-chip class="mx-1" color="primary" label>
                                        <v-icon left>mdi-tag</v-icon>
                                        {{ positions[0].name }}
                                    </v-chip>
                                </v-col>
                            </v-row>

                            <draggable
                                class="row"
                                v-model="d1Banners"
                                group="banner"
                                @start="drag = true"
                                @end="onEnd('d1Banners')"
                            >
                                <v-col
                                    v-for="d1Banner in d1Banners"
                                    :key="d1Banner.id"
                                    class="d-flex child-flex"
                                    cols="4"
                                >
                                    <v-card tile>
                                        <v-card-text>
                                            <div class="action--wrapper" v-if="showDelete">
                                                <v-checkbox
                                                    class="pr-2"
                                                    v-model="deleted"
                                                    :value="d1Banner.id"
                                                >
                                                </v-checkbox>
                                            </div>
                                            <v-img
                                                :src="d1Banner.image.url"
                                                aspect-ratio="1"
                                                class="grey lighten-2"
                                            >
                                                <template v-slot:placeholder>
                                                    <v-row
                                                        class="fill-height ma-0"
                                                        align="center"
                                                        justify="center"
                                                    >
                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>
                                                    </v-row>
                                                </template>
                                            </v-img>
                                        </v-card-text>
                                    </v-card>
                                </v-col>
                            </draggable>

<!--                            <v-row>-->
<!--                                <v-col>-->
<!--                                    <v-chip class="mx-1" color="red" text-color="white" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ $t('desktop_view') }}-->
<!--                                    </v-chip>-->

<!--                                    <v-chip class="mx-1" color="primary" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ positions[1].name }}-->
<!--                                    </v-chip>-->
<!--                                </v-col>-->
<!--                            </v-row>-->

<!--                            <draggable-->
<!--                                class="row"-->
<!--                                v-model="d2Banners"-->
<!--                                group="banner"-->
<!--                                @start="drag = true"-->
<!--                                @end="onEnd('d2Banners')"-->
<!--                            >-->
<!--                                <v-col-->
<!--                                    v-for="d2Banner in d2Banners"-->
<!--                                    :key="d2Banner.id"-->
<!--                                    class="d-flex child-flex"-->
<!--                                    cols="4"-->
<!--                                >-->
<!--                                    <v-card tile>-->
<!--                                        <v-card-text>-->
<!--                                            <div class="action&#45;&#45;wrapper" v-if="showDelete">-->
<!--                                                <v-checkbox-->
<!--                                                    v-if="showDelete"-->
<!--                                                    class="pr-2"-->
<!--                                                    v-model="deleted"-->
<!--                                                    :value="d2Banner.id"-->
<!--                                                >-->
<!--                                                </v-checkbox>-->
<!--                                            </div>-->
<!--                                            <v-img-->
<!--                                                :src="d2Banner.image.url"-->
<!--                                                aspect-ratio="1"-->
<!--                                                class="grey lighten-2"-->
<!--                                            >-->
<!--                                                <template v-slot:placeholder>-->
<!--                                                    <v-row-->
<!--                                                        class="fill-height ma-0"-->
<!--                                                        align="center"-->
<!--                                                        justify="center"-->
<!--                                                    >-->
<!--                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>-->
<!--                                                    </v-row>-->
<!--                                                </template>-->
<!--                                            </v-img>-->
<!--                                        </v-card-text>-->
<!--                                    </v-card>-->
<!--                                </v-col>-->
<!--                            </draggable>-->

<!--                            <v-row>-->
<!--                                <v-col>-->
<!--                                    <v-chip class="mx-1" color="red" text-color="white" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ $t('desktop_view') }}-->
<!--                                    </v-chip>-->

<!--                                    <v-chip class="mx-1" color="primary" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ positions[2].name }}-->
<!--                                    </v-chip>-->
<!--                                </v-col>-->
<!--                            </v-row>-->

<!--                            <draggable-->
<!--                                class="row"-->
<!--                                v-model="d3Banners"-->
<!--                                group="banner"-->
<!--                                @start="drag = true"-->
<!--                                @end="onEnd('d3Banners')"-->
<!--                            >-->
<!--                                <v-col-->
<!--                                    v-for="d3Banner in d3Banners"-->
<!--                                    :key="d3Banner.id"-->
<!--                                    class="d-flex child-flex"-->
<!--                                    cols="4"-->
<!--                                >-->
<!--                                    <v-card tile>-->
<!--                                        <v-card-text>-->
<!--                                            <div class="action&#45;&#45;wrapper" v-if="showDelete">-->
<!--                                                <v-checkbox-->
<!--                                                    v-if="showDelete"-->
<!--                                                    class="pr-2"-->
<!--                                                    v-model="deleted"-->
<!--                                                    :value="d3Banner.id"-->
<!--                                                >-->
<!--                                                </v-checkbox>-->
<!--                                            </div>-->
<!--                                            <v-img-->
<!--                                                :src="d3Banner.image.url"-->
<!--                                                aspect-ratio="1"-->
<!--                                                class="grey lighten-2"-->
<!--                                            >-->
<!--                                                <template v-slot:placeholder>-->
<!--                                                    <v-row-->
<!--                                                        class="fill-height ma-0"-->
<!--                                                        align="center"-->
<!--                                                        justify="center"-->
<!--                                                    >-->
<!--                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>-->
<!--                                                    </v-row>-->
<!--                                                </template>-->
<!--                                            </v-img>-->
<!--                                        </v-card-text>-->
<!--                                    </v-card>-->
<!--                                </v-col>-->
<!--                            </draggable>-->

<!--                            <v-row>-->
<!--                                <v-col>-->
<!--                                    <v-chip class="mx-1" color="red" text-color="white" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ $t('desktop_view') }}-->
<!--                                    </v-chip>-->

<!--                                    <v-chip class="mx-1" color="primary" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ positions[3].name }}-->
<!--                                    </v-chip>-->
<!--                                </v-col>-->
<!--                            </v-row>-->

<!--                            <draggable-->
<!--                                class="row"-->
<!--                                v-model="d4Banners"-->
<!--                                group="banner"-->
<!--                                @start="drag = true"-->
<!--                                @end="onEnd('d4Banners')"-->
<!--                            >-->
<!--                                <v-col-->
<!--                                    v-for="d4Banner in d4Banners"-->
<!--                                    :key="d4Banner.id"-->
<!--                                    class="d-flex child-flex"-->
<!--                                    cols="4"-->
<!--                                >-->
<!--                                    <v-card tile>-->
<!--                                        <v-card-text>-->
<!--                                            <div class="action&#45;&#45;wrapper" v-if="showDelete">-->
<!--                                                <v-checkbox-->
<!--                                                    v-if="showDelete"-->
<!--                                                    class="pr-2"-->
<!--                                                    v-model="deleted"-->
<!--                                                    :value="d4Banner.id"-->
<!--                                                >-->
<!--                                                </v-checkbox>-->
<!--                                            </div>-->
<!--                                            <v-img-->
<!--                                                :src="d4Banner.image.url"-->
<!--                                                aspect-ratio="1"-->
<!--                                                class="grey lighten-2"-->
<!--                                            >-->
<!--                                                <template v-slot:placeholder>-->
<!--                                                    <v-row-->
<!--                                                        class="fill-height ma-0"-->
<!--                                                        align="center"-->
<!--                                                        justify="center"-->
<!--                                                    >-->
<!--                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>-->
<!--                                                    </v-row>-->
<!--                                                </template>-->
<!--                                            </v-img>-->
<!--                                        </v-card-text>-->
<!--                                    </v-card>-->
<!--                                </v-col>-->
<!--                            </draggable>-->

                            <v-row>
                                <v-col>
                                    <v-chip class="mx-1" color="red" text-color="white" label>
                                        <v-icon left>mdi-tag</v-icon>
                                        {{ $t('mobile_view') }}
                                    </v-chip>

                                    <v-chip class="mx-1" color="primary" label>
                                        <v-icon left>mdi-tag</v-icon>
                                        {{ positions[0].name }}
                                    </v-chip>
                                </v-col>
                            </v-row>

                            <draggable
                                class="row"
                                v-model="m1Banners"
                                group="banner"
                                @start="drag = true"
                                @end="onEnd('m1Banners')"
                            >
                                <v-col
                                    v-for="m1Banner in m1Banners"
                                    :key="m1Banner.id"
                                    class="d-flex child-flex"
                                    cols="4"
                                >
                                    <v-card tile>
                                        <v-card-text>
                                            <div class="action--wrapper" v-if="showDelete">
                                                <v-checkbox
                                                    v-if="showDelete"
                                                    class="pr-2"
                                                    v-model="deleted"
                                                    :value="m1Banner.id"
                                                >
                                                </v-checkbox>
                                            </div>
                                            <v-img
                                                :src="m1Banner.image.url"
                                                aspect-ratio="1"
                                                class="grey lighten-2"
                                            >
                                                <template v-slot:placeholder>
                                                    <v-row
                                                        class="fill-height ma-0"
                                                        align="center"
                                                        justify="center"
                                                    >
                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>
                                                    </v-row>
                                                </template>
                                            </v-img>
                                        </v-card-text>
                                    </v-card>
                                </v-col>
                            </draggable>

<!--                            <v-row>-->
<!--                                <v-col>-->
<!--                                    <v-chip class="mx-1" color="red" text-color="white" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ $t('mobile_view') }}-->
<!--                                    </v-chip>-->

<!--                                    <v-chip class="mx-1" color="primary" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ positions[1].name }}-->
<!--                                    </v-chip>-->
<!--                                </v-col>-->
<!--                            </v-row>-->

<!--                            <draggable-->
<!--                                class="row"-->
<!--                                v-model="m2Banners"-->
<!--                                group="banner"-->
<!--                                @start="drag = true"-->
<!--                                @end="onEnd('m2Banners')"-->
<!--                            >-->
<!--                                <v-col-->
<!--                                    v-for="m2Banner in m2Banners"-->
<!--                                    :key="m2Banner.id"-->
<!--                                    class="d-flex child-flex"-->
<!--                                    cols="4"-->
<!--                                >-->
<!--                                    <v-card tile>-->
<!--                                        <v-card-text>-->
<!--                                            <div class="action&#45;&#45;wrapper" v-if="showDelete">-->
<!--                                                <v-checkbox-->
<!--                                                    v-if="showDelete"-->
<!--                                                    class="pr-2"-->
<!--                                                    v-model="deleted"-->
<!--                                                    :value="m2Banner.id"-->
<!--                                                >-->
<!--                                                </v-checkbox>-->
<!--                                            </div>-->
<!--                                            <v-img-->
<!--                                                :src="m2Banner.image.url"-->
<!--                                                aspect-ratio="1"-->
<!--                                                class="grey lighten-2"-->
<!--                                            >-->
<!--                                                <template v-slot:placeholder>-->
<!--                                                    <v-row-->
<!--                                                        class="fill-height ma-0"-->
<!--                                                        align="center"-->
<!--                                                        justify="center"-->
<!--                                                    >-->
<!--                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>-->
<!--                                                    </v-row>-->
<!--                                                </template>-->
<!--                                            </v-img>-->
<!--                                        </v-card-text>-->
<!--                                    </v-card>-->
<!--                                </v-col>-->
<!--                            </draggable>-->

<!--                            <v-row>-->
<!--                                <v-col>-->
<!--                                    <v-chip class="mx-1" color="red" text-color="white" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ $t('mobile_view') }}-->
<!--                                    </v-chip>-->

<!--                                    <v-chip class="mx-1" color="primary" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ positions[2].name }}-->
<!--                                    </v-chip>-->
<!--                                </v-col>-->
<!--                            </v-row>-->

<!--                            <draggable-->
<!--                                class="row"-->
<!--                                v-model="m3Banners"-->
<!--                                group="banner"-->
<!--                                @start="drag = true"-->
<!--                                @end="onEnd('m3Banners')"-->
<!--                            >-->
<!--                                <v-col-->
<!--                                    v-for="m3Banner in m3Banners"-->
<!--                                    :key="m3Banner.id"-->
<!--                                    class="d-flex child-flex"-->
<!--                                    cols="4"-->
<!--                                >-->
<!--                                    <v-card tile>-->
<!--                                        <v-card-text>-->
<!--                                            <div class="action&#45;&#45;wrapper" v-if="showDelete">-->
<!--                                                <v-checkbox-->
<!--                                                    v-if="showDelete"-->
<!--                                                    class="pr-2"-->
<!--                                                    v-model="deleted"-->
<!--                                                    :value="m3Banner.id"-->
<!--                                                >-->
<!--                                                </v-checkbox>-->
<!--                                            </div>-->
<!--                                            <v-img-->
<!--                                                :src="m3Banner.image.url"-->
<!--                                                aspect-ratio="1"-->
<!--                                                class="grey lighten-2"-->
<!--                                            >-->
<!--                                                <template v-slot:placeholder>-->
<!--                                                    <v-row-->
<!--                                                        class="fill-height ma-0"-->
<!--                                                        align="center"-->
<!--                                                        justify="center"-->
<!--                                                    >-->
<!--                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>-->
<!--                                                    </v-row>-->
<!--                                                </template>-->
<!--                                            </v-img>-->
<!--                                        </v-card-text>-->
<!--                                    </v-card>-->
<!--                                </v-col>-->
<!--                            </draggable>-->

<!--                            <v-row>-->
<!--                                <v-col>-->
<!--                                    <v-chip class="mx-1" color="red" text-color="white" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ $t('mobile_view') }}-->
<!--                                    </v-chip>-->

<!--                                    <v-chip class="mx-1" color="primary" label>-->
<!--                                        <v-icon left>mdi-tag</v-icon>-->
<!--                                        {{ positions[3].name }}-->
<!--                                    </v-chip>-->
<!--                                </v-col>-->
<!--                            </v-row>-->

<!--                            <draggable-->
<!--                                class="row"-->
<!--                                v-model="m4Banners"-->
<!--                                group="banner"-->
<!--                                @start="drag = true"-->
<!--                                @end="onEnd('m4Banners')"-->
<!--                            >-->
<!--                                <v-col-->
<!--                                    v-for="m4Banner in m4Banners"-->
<!--                                    :key="m4Banner.id"-->
<!--                                    class="d-flex child-flex"-->
<!--                                    cols="4"-->
<!--                                >-->
<!--                                    <v-card tile>-->
<!--                                        <v-card-text>-->
<!--                                            <div class="action&#45;&#45;wrapper" v-if="showDelete">-->
<!--                                                <v-checkbox-->
<!--                                                    v-if="showDelete"-->
<!--                                                    class="pr-2"-->
<!--                                                    v-model="deleted"-->
<!--                                                    :value="m4Banner.id"-->
<!--                                                >-->
<!--                                                </v-checkbox>-->
<!--                                            </div>-->
<!--                                            <v-img-->
<!--                                                :src="m4Banner.image.url"-->
<!--                                                aspect-ratio="1"-->
<!--                                                class="grey lighten-2"-->
<!--                                            >-->
<!--                                                <template v-slot:placeholder>-->
<!--                                                    <v-row-->
<!--                                                        class="fill-height ma-0"-->
<!--                                                        align="center"-->
<!--                                                        justify="center"-->
<!--                                                    >-->
<!--                                                        <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>-->
<!--                                                    </v-row>-->
<!--                                                </template>-->
<!--                                            </v-img>-->
<!--                                        </v-card-text>-->
<!--                                    </v-card>-->
<!--                                </v-col>-->
<!--                            </draggable>-->
                        </v-container>
                    </v-card-text>

                    <v-card-actions class="pb-5 justify-center">
                        <v-btn
                            v-if="showDelete"
                            class="error"
                            large
                            :loading="deleting"
                            @click="deleteBanners"
                        >
                            <v-icon left>mdi-delete</v-icon>
                            {{ $t('delete') }}
                        </v-btn>

                        <v-btn
                            v-else
                            class="primary"
                            large
                            :disabled="fetchingBanners"
                            :loading="updating"
                            @click="updateBanners"
                        >
                            <v-icon left>mdi-content-save</v-icon>
                            {{ $t('save') }}
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-col>
        </v-row>

        <v-row>
            <v-snackbar
                v-model="snackbar.show"
                :color="snackbar.color"
                :timeout="snackbar.timeout"
            >
                {{ snackbar.message }}

                <template v-slot:action="{ attrs }">
                    <v-btn
                        icon
                        color="white"
                        v-bind="attrs"
                        @click="snackbar.show = false"
                    >
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </template>
            </v-snackbar>
        </v-row>
    </div>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import VImageInput from "../VImageInput";
    import util from "../../../mixins/util"
    import draggable from 'vuedraggable'

    export default {
        name: "Banner",
        components: {
            VImageInput,
            ValidationObserver,
            ValidationProvider,
            draggable
        },
        mixins: [ util ],
        data: () => ({
            minimizePosition: true,
            minimizeUpload: true,
            loading: false,
            updating: false,
            deleting: false,
            showDelete: false,
            fetchingPositions: true,
            fetchingBanners: true,
            viewport: 'desktop',
            position: null,
            origin: [],
            uploading: [],
            desktopBanners: {
                b1: [],
                // b2: [],
                // b3: [],
                // b4: [],
            },
            mobileBanners: {
                b1: [],
                // b2: [],
                // b3: [],
                // b4: []
            },
            positions: [],
            deleted: [],
            editingPosition: null,
            snackbar: {
                show: false,
                color: null,
                timeout: 6000,
                message: ''
            }
        }),

        mounted() {
            this.fetchPositions()
                .then(data => {
                    this.fetchingPositions = false;
                    this.positions = data;
                });

            this.fetchBanners()
                .then(data => {
                    this.fetchingBanners = false;
                    this.origin = data;
                    this.groupBanners(data);
                })
        },

        computed: {
            d1Banners: {
                get() {
                    return this.desktopBanners.b1;
                },

                set(val) {
                    this.desktopBanners.b1 = val.map(v => {
                        if(v.viewport !== 'desktop') {
                            v.viewport = 'desktop';
                        }
                        if(v.position.id !== 1) {
                            v.position.id = 1;
                        }

                        return v;
                    });
                }
            },

            // d2Banners: {
            //     get() {
            //         return this.desktopBanners.b2;
            //     },
            //
            //     set(val) {
            //         this.desktopBanners.b2 = val.map(v => {
            //             if(v.viewport !== 'desktop') {
            //                 v.viewport = 'desktop';
            //             }
            //             if(v.position.id !== 2) {
            //                 v.position.id = 2;
            //             }
            //
            //             return v;
            //         });
            //     }
            // },
            //
            // d3Banners: {
            //     get() {
            //         return this.desktopBanners.b3;
            //     },
            //
            //     set(val) {
            //         this.desktopBanners.b3 = val.map(v => {
            //             if(v.viewport !== 'desktop') {
            //                 v.viewport = 'desktop';
            //             }
            //             if(v.position.id !== 3) {
            //                 v.position.id = 3;
            //             }
            //
            //             return v;
            //         });
            //     }
            // },
            //
            // d4Banners: {
            //     get() {
            //         return this.desktopBanners.b4;
            //     },
            //
            //     set(val) {
            //         this.desktopBanners.b4 = val.map(v => {
            //             if(v.viewport !== 'desktop') {
            //                 v.viewport = 'desktop';
            //             }
            //             if(v.position.id !== 4) {
            //                 v.position.id = 4;
            //             }
            //
            //             return v;
            //         });
            //     }
            // },

            m1Banners: {
                get() {
                    return this.mobileBanners.b1;
                },

                set(val) {
                    this.mobileBanners.b1 = val.map(v => {
                        if(v.viewport !== 'mobile') {
                            v.viewport = 'mobile';
                        }
                        if(v.position.id !== 1) {
                            v.position.id = 1;
                        }

                        return v;
                    });
                }
            },

            // m2Banners: {
            //     get() {
            //         return this.mobileBanners.b2;
            //     },
            //
            //     set(val) {
            //         this.mobileBanners.b2 = val.map(v => {
            //             if(v.viewport !== 'mobile') {
            //                 v.viewport = 'mobile';
            //             }
            //             if(v.position.id !== 2) {
            //                 v.position.id = 2;
            //             }
            //
            //             return v;
            //         });
            //     }
            // },
            //
            // m3Banners: {
            //     get() {
            //         return this.mobileBanners.b3;
            //     },
            //
            //     set(val) {
            //         this.mobileBanners.b3 = val.map(v => {
            //             if(v.viewport !== 'mobile') {
            //                 v.viewport = 'mobile';
            //             }
            //             if(v.position.id !== 3) {
            //                 v.position.id = 3;
            //             }
            //
            //             return v;
            //         });
            //     }
            // },
            //
            // m4Banners: {
            //     get() {
            //         return this.mobileBanners.b4;
            //     },
            //
            //     set(val) {
            //         this.mobileBanners.b4 = val.map(v => {
            //             if(v.viewport !== 'mobile') {
            //                 v.viewport = 'mobile';
            //             }
            //             if(v.position.id !== 4) {
            //                 v.position.id = 4;
            //             }
            //
            //             return v;
            //         });
            //     }
            // }
        },

        methods: {
            onEnd(target) {
                this[target].forEach((banner, index) => {
                    banner.sort = index;
                })
            },

            fetchPositions() {
                this.fetchingPositions = true;

                return new Promise((resolve, reject) => {
                    axios.get('api/banners/positions')
                        .then(({ data }) => {
                            resolve(data.positions);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            fetchBanners() {
                this.fetchingBanners = true;

                return new Promise((resolve, reject) => {
                    axios.get('api/banners')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            upload() {
                this.loading = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            axios.post('api/banners', this.prepareData())
                                .then(({ data }) => {
                                    this.loading = false;
                                    this.uploading = [];
                                    this.$refs.observer.reset();

                                    this.snackbar.show = true;
                                    this.snackbar.color = 'success';
                                    this.snackbar.message = this.$t('banner_uploaded');

                                    this.fetchBanners()
                                        .then(data => {
                                            this.origin = data;
                                            this.fetchingBanners = false;
                                            this.groupBanners(data);
                                        })
                                })
                                .catch(({ response }) => {
                                    this.loading = false;

                                    this.snackbar.show = true;
                                    this.snackbar.color = 'error';

                                    if (response.data.message) {
                                        this.snackbar.message = response.data.message;
                                    }
                                    else if (response.data && response.data.includes('413')) {
                                        this.snackbar.message = this.$t('file_too_large');
                                    }
                                    else {
                                        this.snackbar.message = response.data.message;
                                    }
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    })
            },

            prepareData() {
                let data = this.uploading.map(banner => {
                    return {
                        viewport: this.viewport,
                        banner_position_id: this.position,
                        image: banner
                    }
                });

                return this.objectToFormData({ banners: data });
            },

            groupBanners(banners) {
                let desktopBanners = banners.filter(b => b.viewport === 'desktop');
                this.desktopBanners.b1 = desktopBanners.filter(b => b.position.id === 1);
                // this.desktopBanners.b2 = desktopBanners.filter(b => b.position.id === 2);
                // this.desktopBanners.b3 = desktopBanners.filter(b => b.position.id === 3);
                // this.desktopBanners.b4 = desktopBanners.filter(b => b.position.id === 4);

                let mobileBanners = banners.filter(b => b.viewport === 'mobile');
                this.mobileBanners.b1 = mobileBanners.filter(b => b.position.id === 1);
                // this.mobileBanners.b2 = mobileBanners.filter(b => b.position.id === 2);
                // this.mobileBanners.b3 = mobileBanners.filter(b => b.position.id === 3);
                // this.mobileBanners.b4 = mobileBanners.filter(b => b.position.id === 4);
            },

            updateBanners() {
                this.fetchingBanners = true;
                this.updating = true;

                axios.patch('api/banners', { banners: this.prepareUpdatingBanners() })
                    .then(({ data }) => {
                        this.groupBanners(data);
                        this.updating = false;
                        this.fetchingBanners = false;
                    })
                    .catch(error => {
                        this.updating = false;
                        this.fetchingBanners = false;
                    })
            },

            prepareUpdatingBanners() {
                return this.origin.map(banner => {
                    banner.banner_position_id = banner.position.id;
                    return banner;
                });
            },

            deleteBanners() {
                this.deleting = true;
                this.fetchingBanners = true;

                const payload = {
                    data: {
                        ids: this.deleted
                    }
                };

                axios.delete('api/banners', payload)
                    .then(({ data }) => {
                        this.fetchBanners()
                            .then(data => {
                                this.deleting = false;
                                this.fetchingBanners = false;
                                this.origin = data;
                                this.groupBanners(data);
                            })
                    })
                    .catch(error => {
                        this.deleting = false;
                    })
            },

            updatePositions() {
                this.loading = true;

                this.$refs.positionObserver.validate()
                    .then(valid => {
                        if(valid) {
                            axios.put('api/banners/positions', { positions: this.positions })
                                .then(({ data }) => {
                                    if(data.result) {
                                        this.snackbar.show = true;
                                        this.snackbar.color = 'success';
                                        this.snackbar.message = this.$t('position_updated');
                                    }
                                    this.loading = false;
                                })
                                .catch(error => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    })
            }
        }
    }
</script>

<style scoped>
    .action--wrapper {
        display: flex;
        align-items: center;
        height: 50px;
    }

    .v-input >>> .v-input__prepend-inner {
        margin-top: 12px !important
    }

    .v-input >>> .v-input__append-inner {
        margin-top: 12px !important
    }
</style>
